SynthScrollBarUI (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.plaf.synth, class: SynthScrollBarUI
Keywords: javax.swing.plaf.synth.SynthScrollBarUI class

# Class SynthScrollBarUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.ScrollBarUI
javax.swing.plaf.basic.BasicScrollBarUI
javax.swing.plaf.synth.SynthScrollBarUI

All Implemented Interfaces:
  `LayoutManager, PropertyChangeListener, EventListener, SynthConstants, SynthUI, SwingConstants`

public class SynthScrollBarUI extends BasicScrollBarUI implements PropertyChangeListener, SynthUI
Provides the Synth L&F UI delegate for `JScrollBar`.

Since:
  1.7

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class BasicScrollBarUI

  `BasicScrollBarUI.ArrowButtonListener, BasicScrollBarUI.ModelListener, BasicScrollBarUI.PropertyChangeHandler, BasicScrollBarUI.ScrollListener, BasicScrollBarUI.TrackListener`
  Modifier and Type
  Class
  Description
  `protected class`
  `BasicScrollBarUI.ArrowButtonListener`
  Listener for cursor keys.
  `protected class`
  `BasicScrollBarUI.ModelListener`
  A listener to listen for model changes.
  `class`
  `BasicScrollBarUI.PropertyChangeHandler`
  Property change handler
  `protected class`
  `BasicScrollBarUI.ScrollListener`
  Listener for scrolling events initiated in the `ScrollPane`.
  `protected class`
  `BasicScrollBarUI.TrackListener`
  Track mouse drags.

- ## Field Summary

  ### Fields declared in class BasicScrollBarUI

  `buttonListener, decrButton, DECREASE_HIGHLIGHT, decrGap, incrButton, INCREASE_HIGHLIGHT, incrGap, isDragging, maximumThumbSize, minimumThumbSize, modelListener, NO_HIGHLIGHT, propertyChangeListener, scrollbar, scrollBarWidth, scrollListener, scrollTimer, thumbColor, thumbDarkShadowColor, thumbHighlightColor, thumbLightShadowColor, thumbRect, trackColor, trackHighlight, trackHighlightColor, trackListener, trackRect`
  Modifier and Type
  Field
  Description
  `protected BasicScrollBarUI.ArrowButtonListener`
  `buttonListener`
  Button listener
  `protected JButton`
  `decrButton`
  Decrement button
  `protected static final int`
  `DECREASE_HIGHLIGHT`
  Decrease highlight
  `protected int`
  `decrGap`
  Distance between the decrement button and the track.
  `protected JButton`
  `incrButton`
  Increment button
  `protected static final int`
  `INCREASE_HIGHLIGHT`
  Increase highlight
  `protected int`
  `incrGap`
  Distance between the increment button and the track.
  `protected boolean`
  `isDragging`
  Dragging
  `protected Dimension`
  `maximumThumbSize`
  Maximum thumb size
  `protected Dimension`
  `minimumThumbSize`
  Minimum thumb size
  `protected BasicScrollBarUI.ModelListener`
  `modelListener`
  Model listener
  `protected static final int`
  `NO_HIGHLIGHT`
  No highlight
  `protected PropertyChangeListener`
  `propertyChangeListener`
  Property change listener
  `protected JScrollBar`
  `scrollbar`
  Scrollbar
  `protected int`
  `scrollBarWidth`
  Hint as to what width (when vertical) or height (when horizontal) should be.
  `protected BasicScrollBarUI.ScrollListener`
  `scrollListener`
  Scroll listener
  `protected Timer`
  `scrollTimer`
  Scroll timer
  `protected Color`
  `thumbColor`
  Thumb color
  `protected Color`
  `thumbDarkShadowColor`
  Thumb dark shadow color
  `protected Color`
  `thumbHighlightColor`
  Thumb highlight color
  `protected Color`
  `thumbLightShadowColor`
  Thumb light shadow color
  `protected Rectangle`
  `thumbRect`
  Thumb rectangle
  `protected Color`
  `trackColor`
  Track color
  `protected int`
  `trackHighlight`
  Track highlight
  `protected Color`
  `trackHighlightColor`
  Track highlight color
  `protected BasicScrollBarUI.TrackListener`
  `trackListener`
  Track listener
  `protected Rectangle`
  `trackRect`
  Track rectangle

  ### Fields declared in interface SwingConstants

  `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
  Modifier and Type
  Field
  Description
  `static final int`
  `BOTTOM`
  Box-orientation constant used to specify the bottom of a box.
  `static final int`
  `CENTER`
  The central position in an area.
  `static final int`
  `EAST`
  Compass-direction east (right).
  `static final int`
  `HORIZONTAL`
  Horizontal orientation.
  `static final int`
  `LEADING`
  Identifies the leading edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `LEFT`
  Box-orientation constant used to specify the left side of a box.
  `static final int`
  `NEXT`
  Identifies the next direction in a sequence.
  `static final int`
  `NORTH`
  Compass-direction North (up).
  `static final int`
  `NORTH_EAST`
  Compass-direction north-east (upper right).
  `static final int`
  `NORTH_WEST`
  Compass-direction north west (upper left).
  `static final int`
  `PREVIOUS`
  Identifies the previous direction in a sequence.
  `static final int`
  `RIGHT`
  Box-orientation constant used to specify the right side of a box.
  `static final int`
  `SOUTH`
  Compass-direction south (down).
  `static final int`
  `SOUTH_EAST`
  Compass-direction south-east (lower right).
  `static final int`
  `SOUTH_WEST`
  Compass-direction south-west (lower left).
  `static final int`
  `TOP`
  Box-orientation constant used to specify the top of a box.
  `static final int`
  `TRAILING`
  Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `VERTICAL`
  Vertical orientation.
  `static final int`
  `WEST`
  Compass-direction west (left).

  ### Fields declared in interface SynthConstants

  `DEFAULT, DISABLED, ENABLED, FOCUSED, MOUSE_OVER, PRESSED, SELECTED`
  Modifier and Type
  Field
  Description
  `static final int`
  `DEFAULT`
  Indicates the region is the default.
  `static final int`
  `DISABLED`
  Primary state indicating the region is not enabled.
  `static final int`
  `ENABLED`
  Primary state indicating the component is enabled.
  `static final int`
  `FOCUSED`
  Indicates the region has focus.
  `static final int`
  `MOUSE_OVER`
  Primary state indicating the mouse is over the region.
  `static final int`
  `PRESSED`
  Primary state indicating the region is in a pressed state.
  `static final int`
  `SELECTED`
  Indicates the region is selected.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SynthScrollBarUI()`
  Constructs a `SynthScrollBarUI`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ComponentUI`
  `createUI(JComponent c)`
  Returns a UI.
  `SynthContext`
  `getContext(JComponent c)`
  Returns the Context for the specified component.
  `Dimension`
  `getPreferredSize(JComponent c)`
  A vertical scrollbar's preferred width is the maximum of preferred widths of the (non `null`) increment/decrement buttons, and the minimum width of the thumb.
  `void`
  `paint(Graphics g, JComponent c)`
  Paints the specified component according to the Look and Feel.
  `protected void`
  `paint(SynthContext context, Graphics g)`
  Paints the specified component.
  `void`
  `paintBorder(SynthContext context, Graphics g, int x, int y, int w, int h)`
  Paints the border.
  `protected void`
  `paintThumb(SynthContext context, Graphics g, Rectangle thumbBounds)`
  Paints the scrollbar thumb.
  `protected void`
  `paintTrack(SynthContext context, Graphics g, Rectangle trackBounds)`
  Paints the scrollbar track.
  `void`
  `propertyChange(PropertyChangeEvent e)`
  This method gets called when a bound property is changed.
  `void`
  `update(Graphics g, JComponent c)`
  Notifies this UI delegate to repaint the specified component.

  ### Methods declared in class BasicScrollBarUI

  `addLayoutComponent, configureScrollBarColors, createArrowButtonListener, createDecreaseButton, createIncreaseButton, createModelListener, createPropertyChangeListener, createScrollListener, createTrackListener, getMaximumSize, getMaximumThumbSize, getMinimumThumbSize, getSupportsAbsolutePositioning, getThumbBounds, getTrackBounds, installComponents, installDefaults, installKeyboardActions, installListeners, installUI, isThumbRollover, layoutContainer, layoutHScrollbar, layoutVScrollbar, minimumLayoutSize, paintDecreaseHighlight, paintIncreaseHighlight, paintThumb, paintTrack, preferredLayoutSize, removeLayoutComponent, scrollByBlock, scrollByUnit, setThumbBounds, setThumbRollover, uninstallComponents, uninstallDefaults, uninstallKeyboardActions, uninstallListeners, uninstallUI`
  Modifier and Type
  Method
  Description
  `void`
  `addLayoutComponent(String name, Component child)`
  If the layout manager uses a per-component string, adds the component `comp` to the layout, associating it with the string specified by `name`.
  `protected void`
  `configureScrollBarColors()`
  Configures the scroll bar colors.
  `protected BasicScrollBarUI.ArrowButtonListener`
  `createArrowButtonListener()`
  Creates an arrow button listener.
  `protected JButton`
  `createDecreaseButton(int orientation)`
  Creates a decrease button.
  `protected JButton`
  `createIncreaseButton(int orientation)`
  Creates an increase button.
  `protected BasicScrollBarUI.ModelListener`
  `createModelListener()`
  Creates a model listener.
  `protected PropertyChangeListener`
  `createPropertyChangeListener()`
  Creates a property change listener.
  `protected BasicScrollBarUI.ScrollListener`
  `createScrollListener()`
  Creates a scroll listener.
  `protected BasicScrollBarUI.TrackListener`
  `createTrackListener()`
  Creates a track listener.
  `Dimension`
  `getMaximumSize(JComponent c)`
  Returns the specified component's maximum size appropriate for the look and feel.
  `protected Dimension`
  `getMaximumThumbSize()`
  Returns the largest acceptable size for the thumb.
  `protected Dimension`
  `getMinimumThumbSize()`
  Returns the smallest acceptable size for the thumb.
  `boolean`
  `getSupportsAbsolutePositioning()`
  Indicates whether the user can absolutely position the thumb with a mouse gesture (usually the middle mouse button).
  `protected Rectangle`
  `getThumbBounds()`
  Return the current size/location of the thumb.
  `protected Rectangle`
  `getTrackBounds()`
  Returns the current bounds of the track, i.e. the space in between the increment and decrement buttons, less the insets.
  `protected void`
  `installComponents()`
  Installs the components.
  `protected void`
  `installDefaults()`
  Installs the defaults.
  `protected void`
  `installKeyboardActions()`
  Installs the keyboard actions.
  `protected void`
  `installListeners()`
  Installs the listeners.
  `void`
  `installUI(JComponent c)`
  Installs the UI.
  `boolean`
  `isThumbRollover()`
  Returns true if the mouse is currently over the thumb.
  `void`
  `layoutContainer(Container scrollbarContainer)`
  Lays out the specified container.
  `protected void`
  `layoutHScrollbar(JScrollBar sb)`
  Lays out a horizontal scroll bar.
  `protected void`
  `layoutVScrollbar(JScrollBar sb)`
  Lays out a vertical scroll bar.
  `Dimension`
  `minimumLayoutSize(Container scrollbarContainer)`
  Calculates the minimum size dimensions for the specified container, given the components it contains.
  `protected void`
  `paintDecreaseHighlight(Graphics g)`
  Paints the decrease highlight.
  `protected void`
  `paintIncreaseHighlight(Graphics g)`
  Paints the increase highlight.
  `protected void`
  `paintThumb(Graphics g, JComponent c, Rectangle thumbBounds)`
  Paints the thumb.
  `protected void`
  `paintTrack(Graphics g, JComponent c, Rectangle trackBounds)`
  Paints the track.
  `Dimension`
  `preferredLayoutSize(Container scrollbarContainer)`
  Calculates the preferred size dimensions for the specified container, given the components it contains.
  `void`
  `removeLayoutComponent(Component child)`
  Removes the specified component from the layout.
  `protected void`
  `scrollByBlock(int direction)`
  Scrolls by block.
  `protected void`
  `scrollByUnit(int direction)`
  Scrolls by unit.
  `protected void`
  `setThumbBounds(int x, int y, int width, int height)`
  Set the bounds of the thumb and force a repaint that includes the old thumbBounds and the new one.
  `protected void`
  `setThumbRollover(boolean active)`
  Sets whether or not the mouse is currently over the thumb.
  `protected void`
  `uninstallComponents()`
  Uninstalls the components.
  `protected void`
  `uninstallDefaults()`
  Uninstalls the defaults.
  `protected void`
  `uninstallKeyboardActions()`
  Uninstalls the keyboard actions.
  `protected void`
  `uninstallListeners()`
  Uninstall the listeners.
  `void`
  `uninstallUI(JComponent c)`
  Uninstalls the UI.

  ### Methods declared in class ComponentUI

  `contains, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, getMinimumSize`
  Modifier and Type
  Method
  Description
  `boolean`
  `contains(JComponent c, int x, int y)`
  Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
  `Accessible`
  `getAccessibleChild(JComponent c, int i)`
  Returns the `i`th `Accessible` child of the object.
  `int`
  `getAccessibleChildrenCount(JComponent c)`
  Returns the number of accessible children in the object.
  `int`
  `getBaseline(JComponent c, int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior(JComponent c)`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `Dimension`
  `getMinimumSize(JComponent c)`
  Returns the specified component's minimum size appropriate for the look and feel.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### SynthScrollBarUI

    public SynthScrollBarUI()
    Constructs a `SynthScrollBarUI`.

- ## Method Details

  - ### createUI

    public static ComponentUI createUI(JComponent c)
    Returns a UI.
    Parameters:
      `c` - a component
    Returns:
      a UI

  - ### getContext

    public SynthContext getContext(JComponent c)
    Returns the Context for the specified component.
    Specified by:
      `getContext` in interface `SynthUI`
    Parameters:
      `c` - Component requesting SynthContext.
    Returns:
      SynthContext describing component.

  - ### update

    public void update(Graphics g, JComponent c)
    Notifies this UI delegate to repaint the specified component. This method paints the component background, then calls the `paint(SynthContext,Graphics)` method.

    In general, this method does not need to be overridden by subclasses. All Look and Feel rendering code should reside in the `paint` method.

    Overrides:
      `update` in class `ComponentUI`
    Parameters:
      `g` - the `Graphics` object used for painting
      `c` - the component being painted
    See Also:
      - `paint(SynthContext,Graphics)`

  - ### paint

    public void paint(Graphics g, JComponent c)
    Paints the specified component according to the Look and Feel.

    This method is not used by Synth Look and Feel. Painting is handled by the `paint(SynthContext,Graphics)` method.

    Overrides:
      `paint` in class `ComponentUI`
    Parameters:
      `g` - the `Graphics` object used for painting
      `c` - the component being painted
    See Also:
      - `paint(SynthContext,Graphics)`

  - ### paint

    protected void paint(SynthContext context, Graphics g)
    Paints the specified component.
    Parameters:
      `context` - context for the component being painted
      `g` - the `Graphics` object used for painting
    See Also:
      - `update(Graphics,JComponent)`

  - ### paintBorder

    public void paintBorder(SynthContext context, Graphics g, int x, int y, int w, int h)
    Paints the border.
    Specified by:
      `paintBorder` in interface `SynthUI`
    Parameters:
      `context` - a component context
      `g` - `Graphics` to paint on
      `x` - the X coordinate
      `y` - the Y coordinate
      `w` - width of the border
      `h` - height of the border

  - ### paintTrack

    protected void paintTrack(SynthContext context, Graphics g, Rectangle trackBounds)
    Paints the scrollbar track.
    Parameters:
      `context` - context for the component being painted
      `g` - `Graphics` object used for painting
      `trackBounds` - bounding box for the track

  - ### paintThumb

    protected void paintThumb(SynthContext context, Graphics g, Rectangle thumbBounds)
    Paints the scrollbar thumb.
    Parameters:
      `context` - context for the component being painted
      `g` - `Graphics` object used for painting
      `thumbBounds` - bounding box for the thumb

  - ### getPreferredSize

    public Dimension getPreferredSize(JComponent c)
    A vertical scrollbar's preferred width is the maximum of preferred widths of the (non `null`) increment/decrement buttons, and the minimum width of the thumb. The preferred height is the sum of the preferred heights of the same parts. The basis for the preferred size of a horizontal scrollbar is similar.

    The `preferredSize` is only computed once, subsequent calls to this method just return a cached size.

    Overrides:
      `getPreferredSize` in class `BasicScrollBarUI`
    Parameters:
      `c` - the `JScrollBar` that's delegating this method to us
    Returns:
      the preferred size of a Basic JScrollBar
    See Also:
      - `BasicScrollBarUI.getMaximumSize(JComponent)`
      - `ComponentUI.getMinimumSize(JComponent)`

  - ### propertyChange

    public void propertyChange(PropertyChangeEvent e)
    Description copied from interface: `PropertyChangeListener`
    This method gets called when a bound property is changed.
    Specified by:
      `propertyChange` in interface `PropertyChangeListener`
    Parameters:
      `e` - A PropertyChangeEvent object describing the event source and the property that has changed.